#include <iostream>

#include "./src/rvb_math.h"

using namespace std;

int main(int argc, char *argv[])
{
  (void)argc; // unused parameter
  (void)argv; // unused parameter

  cout << "RVB reference implementation.\n" << endl;

  cout << "Self test with parameters selected at random:" << endl;
  if (!RVB::test_RVB<RVB::big_float_n>(100)) {
    cout << "RVB self test with parameters selected at random NOT passed. Accuracy setting: 100 decimal digits.\n" << endl;
    return 0;
  }
  else
    cout << "RVB self test with parameters selected at random passed. Accuracy setting: 100 decimal digits.\n" << endl;


  cout << "\nSelf test with test vectors:\n" << endl;

  cout << "Self test with fixed test vector at 100 decimal digits targeted accuracy:\n" << endl;
  if (!RVB::test_RVB_using_test_vectors<RVB::big_float_n>(100)) {
    cout << "RVB self test with vector NOT passed. Accuracy setting: 100 decimal digits.\n" << endl;
    return 0;
  }
  else
    cout << "RVB self test with vector passed. Accuracy setting: 100 decimal digits.\n" << endl;

  cout << "Self test with fixed test vector at 200 decimal digits targeted accuracy:\n" << endl;
  if (!RVB::test_RVB_using_test_vectors<RVB::big_float_l>(200)) {
    cout << "RVB self test with vector NOT passed. Accuracy setting: 200 decimal digits.\n" << endl;
    return 0;
  }
  else
    cout << "RVB self test with vector passed. Accuracy setting: 200 decimal digits.\n" << endl;


  cout << "Self test with fixed test vector at 300 decimal digits targeted accuracy:\n" << endl;
  if (!RVB::test_RVB_using_test_vectors<RVB::big_float_x>(300)) {
    cout << "RVB self test with vector NOT passed. Accuracy setting: 300 decimal digits.\n" << endl;
    return 0;
  }
  else
    cout << "RVB self test with vector passed. Accuracy setting: 300 decimal digits.\n" << endl;


  cout << "Speed test at accuracy set to 100 decimal digits. Performing 2 * 50 key exchanges (Alice + Bob)..." << endl;
  double dSeconds=RVB::speed_test_RVB<RVB::big_float_n>(100,50);

  cout << "Speed test at accuracy set to 200 decimal digits. Performing 2 * 20 key exchanges (Alice + Bob)..." << endl;
  dSeconds=RVB::speed_test_RVB<RVB::big_float_l>(200,20);

  cout << "Speed test at accuracy set to 300 decimal digits. Performing 2 * 10 key exchanges (Alice + Bob)..." << endl;
  dSeconds=RVB::speed_test_RVB<RVB::big_float_x>(300,10);


  // Additional test: simply uncomment if you want to give it a try ..
//  cout << "Testing RVB near roots:\n" << endl;
//  RVB::test_RVB_around_roots<RVB::big_float_n>(100);

  return 0;
}
