msvc {
  QMAKE_CXXFLAGS += -openmp -arch:AVX -D "_CRT_SECURE_NO_WARNINGS"
  QMAKE_CXXFLAGS_RELEASE *= -O2
}

gcc {
  QMAKE_CXXFLAGS += -fopenmp -mavx -fabi-version=0 -ffast-math
  QMAKE_LFLAGS += -fopenmp
  QMAKE_CXXFLAGS_RELEASE *= -O3
}

TEMPLATE = app
CONFIG += console c++11
#CONFIG += warn_off
CONFIG -= app_bundle
CONFIG -= qt

SOURCES += main.cpp \
    src/intel_cpu.cpp \
    src/rvb_math.cpp

HEADERS += \
    src/intel_cpu.h \
    src/rvb_math.h \
    src/ttmath/ttmath.h \
    src/ttmath/ttmathbig.h \
    src/ttmath/ttmathdec.h \
    src/ttmath/ttmathint.h \
    src/ttmath/ttmathmisc.h \
    src/ttmath/ttmathobjects.h \
    src/ttmath/ttmathparser.h \
    src/ttmath/ttmaththreads.h \
    src/ttmath/ttmathtypes.h \
    src/ttmath/ttmathuint_noasm.h \
    src/ttmath/ttmathuint_x86_64.h \
    src/ttmath/ttmathuint_x86.h \
    src/ttmath/ttmathuint.h \
    src/os.h

DISTFILES += \
    src/ttmath/ttmathuint_x86_64_msvc.asm
